#include <math.h>
#include "tft_master.h"
#include "tft_gfx.h"

// ==================
// graphics libraries
#include "config.h"
#include "pt_cornell_1_2.h"
#include "nrf24l01.h"

// need for rand function
#include <stdlib.h>
#include <stdint.h>
// threading library
#include <plib.h>
// config.h sets 40 MHz
#define	SYS_FREQ 40000000
#define OPCODE_DELETE_USER 'a'
#define OPCODE_DELETE_FILES 'b'

// pin 3  RPA1  - SPI 1 MOSI
// pin 5  RPB1  - SPI 1 CS 
// pin 6  RPB2  - SPI 1 CE
// pin 22 RPB11 - SPI 1 MISO
// pin 25 RPB14 - SPI 1 SCLK 

// SPI 1 - NRF24L01

uint8_t addr1[5];                                                                                                                       
char buffer[60];
unsigned char text[32];
unsigned char b[3]={10,5,4};
static int rx=119;
static int ry=290;
static int vx=0;
static int vy=0;
static int rx_old=119;
static int ry_old=290;
void main(void) {
     
 SYSTEMConfigPerformance(sys_clock);
  
  ANSELA = 0; ANSELB = 0; CM1CON = 0; CM2CON = 0;
  // === setup system wide interrupts  ========
  INTEnableSystemMultiVectoredInt();

  
  
  tft_init_hw();
  tft_begin();
  tft_fillScreen(ILI9340_BLACK);
  //240x320 vertical display
  tft_setRotation(0); // Use tft_setRotation(1) for 320x240

  // seed random color
  srand(1);
  // initial RF
  tft_drawLine(0,0,0,319,ILI9340_GREEN);
  tft_drawLine(0,319,239,319,ILI9340_GREEN);
  tft_drawLine(0,0,239,0,ILI9340_GREEN);
  tft_drawLine(239,319,239,0,ILI9340_GREEN);
  

  int ret = rf24_init();
  //addr1 = 0xB00B1E5000LL;
    addr1[0] = 0xAB;
    addr1[1] = 0xCD;
    addr1[2] = 0xAB;
    addr1[3] = 0xCD;
    addr1[4] = 0x71;
//   mPORTASetPinsDigitalOut(BIT_0);
//   mPORTBSetPinsDigitalOut(BIT_0);
//   mPORTBSetPinsDigitalOut(BIT_3);
//   mPORTAClearBits(BIT_0);
//   mPORTBClearBits(BIT_0);
//   mPORTBClearBits(BIT_3);   
    mPORTBSetPinsDigitalOut(BIT_5); // pin14
    mPORTBClearBits(BIT_5);
    mPORTBSetPinsDigitalOut(BIT_4); // pin11
    mPORTBClearBits(BIT_4);
    
    
    rf24_set_amplifier_level(RF24_PA_LOW);
    rf24_set_retries(15,15);
    rf24_set_auto_ack_all(1);
    rf24_open_read_pipe(1,addr1);
    rf24_start_listening();
  
while(1){
            rf24_read(text,sizeof(text));
                           
            tft_setCursor(45, 20);
            tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(2);
            sprintf(buffer,"3D MOUSE APP");
            tft_writeString(buffer);
            
            tft_setCursor(16, 60);
            tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(1);
            sprintf(buffer,"By Pei Xu; Chang Liu; Zhen Zhen Lin");
            tft_writeString(buffer);
                        
            tft_setCursor(70, 120);
            tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(1);
            sprintf(buffer,"===============");
            tft_writeString(buffer);
            tft_setCursor(70, 130);
            tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(1);
            sprintf(buffer,"=             =");
            tft_writeString(buffer);
            tft_setCursor(70, 140);
            tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(1);
            sprintf(buffer,"=  NEXT SONG  =");
            tft_writeString(buffer);
            tft_setCursor(70, 150);
            tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(1);
            sprintf(buffer,"=             =");
            tft_writeString(buffer);
            tft_setCursor(70, 160);
            tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(1);
            sprintf(buffer,"===============");
            tft_writeString(buffer);
            
            tft_setCursor(70, 180);
            tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(1);
            sprintf(buffer,"===============");
            tft_writeString(buffer);
            tft_setCursor(70, 190);
            tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(1);
            sprintf(buffer,"=             =");
            tft_writeString(buffer);
            tft_setCursor(70, 200);
            tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(1);
            sprintf(buffer,"= PAUSE /PLAY =");
            tft_writeString(buffer);
            tft_setCursor(70, 210);
            tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(1);
            sprintf(buffer,"=             =");
            tft_writeString(buffer);
            tft_setCursor(70, 220);
            tft_setTextColor(ILI9340_YELLOW); tft_setTextSize(1);
            sprintf(buffer,"===============");
            tft_writeString(buffer);
            
            
            vx=3*text[0];           
            vy=3*text[1]; 
            
            if(rx_old!=rx || ry_old!=ry) {               
            tft_fillCircle(rx_old,ry_old,8,ILI9340_BLACK);
            }
            
            rx_old = rx;
            ry_old = ry;
            
            if(text[2]==4 && rx< 233-vx && ry< 312-vy){
                
                            rx=rx+vx;
                            ry=ry+vy;
            }
            if(text[2]==3 && rx> 8+vx && ry< 312-vy){
                            rx=rx-vx;
                            ry=ry+vy;
            }
            if(text[2]==2 && rx> 8+vx && ry> 6+vy){
                            rx=rx-vx;
                            ry=ry-vy;
            }
            if(text[2]==1 && rx< 233-vx && ry> 6+vy){
                            rx=rx+vx;
                            ry=ry-vy;
            }
            
            tft_fillCircle(rx,ry,8,ILI9340_RED);
           
           if(rx>=70&&rx<=170&&ry>=120&&ry<=160&&(text[3]==1)){
                mPORTBSetBits(BIT_5);
            }
            
           else{mPORTBClearBits(BIT_5);}
            
           if(rx>=70&&rx<=170&&ry>=180&&ry<=220&&(text[3]==1)){
                mPORTBSetBits(BIT_4);
                 
           }
           else{mPORTBClearBits(BIT_4);}
    
          }
    
  }
        
